package page;

import conf.Api;
import conf.Config;
import io.restassured.response.Response;


import java.util.HashMap;

public class LoginPage extends Api {
    private static LoginPage loginPage;
    private String token;
    private Integer member_id;
    Config config=Config.getInstance();

    private LoginPage(){
    }

    public static LoginPage getInstance() {
        if(loginPage==null){
            loginPage=new LoginPage();
            return loginPage;
        }
        return loginPage;
    }

    public Response passwordLoginSuccess(HashMap<String,Object> map){
        return getResponseFromYaml("/api/page/loginPage/pcpLoginByType.yaml",map);
    }

    public String getToken() {
        if(token==null){
            HashMap<String,Object> body=new HashMap<>();
            body.put("_file","/apijson/page/loginPage/pcpLoginByType.json");
            body.put("username",config.username);
            body.put("password",config.password);
            Response response=getResponseFromYaml("/api/page/loginPage/pcpLoginByType.yaml",body);
            token= response.path("data.token");
            member_id=response.path("data.member_id");
            return token;
        }else {
            return token;
        }
    }

    public Integer getMember_id() {
        return member_id;
    }
}
