package page;

import io.qameta.allure.Description;
import io.qameta.allure.Story;
import io.restassured.response.Response;
import org.testng.Reporter;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;
import util.JDBCUtils;

import java.util.Base64;
import java.util.HashMap;
import java.util.List;

import static org.testng.Assert.*;

public class MyPageTest {
    MyPage myPage=new MyPage();
    LoginPage loginPage=LoginPage.getInstance();

    @BeforeClass
    public void beforeClass(){
        loginPage.getToken();
    }

    @Test
    @Description("正常测试用例：获取已读政策")
    @Story("我的")
    public void findsReadZC(){
        try{
            List<Object[]> sql= JDBCUtils.queryMulti("SELECT id from oa_zhengce where status=1 and zhijian_status=5 and id not in (SELECT zid FROM applet_read_policy where member_id='"+loginPage.getMember_id()+"');");
            HashMap<String,Object> body1=new HashMap<>();
            body1.put("_file","/apijson/page/myPage/pcpPolicyDetailAddZCHistory.json");
            body1.put("zid",sql.get(0)[0]);
            body1.put("memberId",loginPage.getMember_id());
            Response response1= myPage.addZCHistory(body1);
            assertEquals(response1.path("message"),"操作成功");
            HashMap<String,Object> map=new HashMap<>();
            map.put("_file","/apijson/page/myPage/pcpPersonalCenterFindIsReadZC.json");
            map.put("memberId",loginPage.getMember_id());
            Response response2= myPage.findsReadZC(map);
            assertEquals((int) response2.path("code"),200);
            assertEquals(response2.path("message"),"操作成功");
            List<Integer> list=response2.path("data.id");
            assertEquals(list.get(0),sql.get(0)[0]);
        }catch (AssertionError e){
            Reporter.log("MyPageTest.findsReadZC：获取已读政策，断言失败！");
            throw  e;
        }
    }


}