package page;

import io.qameta.allure.Description;
import io.qameta.allure.Story;
import io.restassured.response.Response;
import org.testng.Reporter;
import org.testng.annotations.Test;
import util.JDBCUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static org.testng.Assert.*;

public class SpecialPageTest {
    SpecialPage specialPage=new SpecialPage();

    @Test
    @Description("正常测试用例：查询所有政策专题")
    @Story("政策专题")
    public void getPolicyTopic(){
        try{
            List<Object[]> sql= JDBCUtils.queryMulti("select pc_img,name,content from back_sys_topic where is_delete='0' and status='0' order by sort;");
            Response response= specialPage.getPolicyTopic();
            assertEquals((int)response.path("code"),200);
            assertEquals(response.path("message"),"操作成功");
            ArrayList<HashMap<String,String>> result=response.path("data");
            for (int i=0;i<result.size();i++){
                assertEquals(result.get(i).get("cover"),sql.get(i)[0]);
                assertEquals(result.get(i).get("name"),sql.get(i)[1]);
                assertEquals(result.get(i).get("describe"),sql.get(i)[2]);
            }
        }catch (AssertionError e){
            Reporter.log("SpecialPageTest.getPolicyTopic：查询所有政策专题，断言失败！");
            throw  e;
        }
    }

    @Test
    @Description("正常测试用例：查询专题关联的项目")
    @Story("政策专题")
    public void policyTopicList(){
        try{
            List<Object[]> sql= JDBCUtils.queryMulti("select id from back_sys_topic where is_delete='0' and status='0' order by sort;");
            List<Object[]> project= JDBCUtils.queryMulti("select oa_formal_file.subtitle,oa_zhengce.fw_department from oa_formal_file INNER JOIN oa_zhengce on oa_formal_file.zhengceid=oa_zhengce.id where oa_formal_file.id in(SELECT formal FROM back_sys_topic_formal where topic_id=5) and oa_formal_file.status=1 and oa_formal_file.zhijian_status=5;");
            HashMap<String,Object> map=new HashMap<>();
            map.put("_file", "/apijson/page/specialPage/pcpIndexGetPolicyTopicPolicyTopicList.json");
            map.put("id",sql.get(0)[0]);
            Response response= specialPage.policyTopicList(map);
            assertEquals((int)response.path("code"),200);
            assertEquals(response.path("message"),"操作成功");
            assertTrue(((List)response.path("data")).size()>0);
        }catch (AssertionError e){
            Reporter.log("SpecialPageTest.policyTopicList：查询专题关联的项目，断言失败！");
            throw  e;
        }
//        boolean b=false;
//        for(int i=1;i<result.size();i++){
//            String sub=result.get(i).get("subtitle");
//            String fwd=result.get(i).get("fwDepartment");
//            System.out.println(sub);
//            System.out.println(fwd);
//            for(int j=0;j<project.size();j++){
//                if (project.get(j)[0].equals(sub) && project.get(j)[1].equals(fwd)){
//                    b=true;
//                }
//            }
//            if(b==false){
//                break;
//            }
//        }
//        assertTrue(b);
    }
}